/// <reference types="q" />
import * as plugins from "./smartnginx.plugins";
/**
 * the host config data that NginxHost needs to create a valid instance
 */
export interface IHostConfigData {
    hostName: string;
    type: hostTypes;
    destination: string;
}
export declare enum hostTypes {
    reverseProxy = 0,
    static = 1,
}
/**
 * manages a single nginx host
 */
export declare class NginxHost {
    hostName: string;
    type: hostTypes;
    destination: string;
    configString: string;
    constructor(optionsArg: IHostConfigData);
    deploy(certInstanceArg: plugins.cert.Cert): plugins.q.Promise<{}>;
}
